﻿@{
    Layout = "~/Views/Layout/Dashboard.cshtml";
}

@using Toyota.Common.Web.MVC
@using Toyota.Common.Web.Html
@using Toyota.Common.Web.Html.Helper

@model Toyota.Common.Web.MVC.ModelHolder

@section StyleReferences {}

@section Style {
    .searchButton {
        float: right;
        margin-left: 5px;
    }

    .searchButtonArea {
        margin-top: 15px;
    }

    td.cmFormLabel {
        padding-right: 10px;
    }

    td.cmFormField {
        padding-right: 30px;
    }

    .searchParamPanel,
    #searchResultTable {
        float: left;
    }

    #searchResultTable {
        width: 100%;
        padding-top: 30px;
        clear: both;
    }

    .searchResultTableButtons {
        margin-left: 5px;
        float: right;
    }

    #upperGridButtons {
        height: 30px;
        margin-right: 10px;
    }
    
    .editTemplate {
        position: relative;       
    }

    .editTemplateFormSection,
    .editTemplateButtonsSection {
        float: left;
    }

    .editTemplateFormSection {
        width: 70%;
    }

    .editTemplateButtonsSection {
        width: 25%;        
    }

    .editTemplateButton {
        float: right;
        margin-left: 5px;
    }

    .SelectionCheckbox {
        width: 10px;
        height: 10px;
        border: 1px dotted #000;
        cursor: pointer;
    }

    .SelectionCheckbox-Selected {
        width: 16px;
        height: 16px;
        border: none;
        cursor: pointer;
        background-image: url("../../../Content/Images/Common/Check.png");
        background-repeat: no-repeat;
        background-position: 0 0;
    }   
}

@{
    LayoutPageModel model = Model.GetModel<LayoutPageModel>();
    IHtmlComponent[] searchComponents = model.GetControls(MaintenanceController.AREA_SEARCH_PARAMETER);
    IHtmlComponent cmpDataGrid = model.GetControl(MaintenanceController.AREA_DATAGRID);
    string dataGridId = HtmlComponentHelper.GenerateComponentId(cmpDataGrid);
    string id;
}

@section StartupScript {}

@section Script {
    var DataGridCallbackParamMap = {};

    function clearSearchFields() {
        @if (searchComponents != null)
        {   
            foreach (IHtmlComponent comp in searchComponents)
            { 
                id = HtmlComponentHelper.GenerateComponentId(comp);  
                @:$('[name *= "@id"]').val("");
            }
        }
    }

    function PerformDataGridCallback() {
        @{
            ViewContext.Writer.WriteLine(string.Format(
                    "if(!{0}.InCallback()) {{" +
                    "   {1}.PerformCallback();" +
                    "}}", dataGridId, dataGridId
            ));            
        }        
    }

    function toggleSelectionCheckbox(control) {        
        var id = $(control).attr("id");
        var idFractions = id.split("-");
        var grid = @dataGridId; 
        if($(control).hasClass("SelectionCheckbox-Selected")) {
            $(control).removeClass("SelectionCheckbox-Selected");
            $(control).addClass("SelectionCheckbox");
            grid.SelectRowsByKey($.trim(idFractions[1]), false);
        } else {
            $(control).removeClass("SelectionCheckbox");
            $(control).addClass("SelectionCheckbox-Selected");
            grid.SelectRowsByKey($.trim(idFractions[1]), true);
        }
    }

    function OnBeginUpdateSearchResult(s, e) {
        @if (searchComponents != null)
        {   
            foreach (IHtmlComponent comp in searchComponents)
            { 
                id = HtmlComponentHelper.GenerateComponentId(comp);  
                @: e.customArgs["@comp.GetId()"] = $('[name *= "@id"]').val();
            }

            @:$.each(DataGridCallbackParamMap, function(key, value) {
            @:  e.customArgs[key] = value;
            @:});
        }        
    }

    function OnEndUpdateSearchResult() {
        DataGridCallbackParamMap["Operation"] = "";
    }

    function UpdateSearchResult(s, e) {      
        var param = {};  
        @{
            foreach (IHtmlComponent comp in searchComponents)
            { 
                id = HtmlComponentHelper.GenerateComponentId(comp);  
                @: param["@id"] = $('[name *= "@id"]').val();
            }
        }

        cmInputValidator.validate("Search", param, function(validation) {            
            cmScreenMessageStack.update();
        });

        PerformDataGridCallback();
    }

    function AddNewRecord(s, e) {
        @{
            ViewContext.Writer.WriteLine(string.Format(
                    "{0}.AddNewRow();", dataGridId
            ));
        }
    }

    function CancelEditing(s, e) {
        @{
            ViewContext.Writer.WriteLine(string.Format(
                    "{0}.CancelEdit();", dataGridId
            ));
        }
    }

    function UpdateEdit(s, e) {
        @{
            ViewContext.Writer.WriteLine(string.Format(
                    "{0}.UpdateEdit();", dataGridId
            ));
        }
    }

    function DeleteRecords(s, e) {   
        $selectedChecks = $("div.SelectionCheckbox-Selected");
        var id;
        var idFractions;
        var keyFraction;
        var selectedKeyString = "";
        if(($selectedChecks != 'undefined') && ($selectedChecks.length > 0)) {
            $selectedChecks.each(function() {
                id = $(this).attr("id");
                idFractions = id.split("-");
                selectedKeyString = selectedKeyString + " " + idFractions[1] + "/";             
            });
            
            selectedKeyString = $.trim(selectedKeyString);
            selectedKeyString = selectedKeyString.slice(0, selectedKeyString.length - 1);
            DataGridCallbackParamMap["Operation"] = "Delete";
            DataGridCallbackParamMap["SelectedKeys"] = selectedKeyString;

            var grid = @dataGridId; 
            grid.UnselectRows();
            PerformDataGridCallback();
        }        
    }

    function CommandButtonClicked(s, e) {    
        if(e.buttonID == 'btEdit') {
            @{
                ViewContext.Writer.WriteLine(string.Format(
                        "{0}.StartEditRow(e.visibleIndex);", dataGridId
                ));
            }
        } else if(e.buttonID == 'btDelete') {
            @{
                ViewContext.Writer.WriteLine(string.Format(
                        "{0}.DeleteRow(e.visibleIndex);", dataGridId
                ));
            }
        }
    }

    function ClearResultSelections() {        
        $selectedChecks = $("div.SelectionCheckbox-Selected");
        if(($selectedChecks != 'undefined') && ($selectedChecks.length > 0)) {
            var grid = @dataGridId; 
            grid.UnselectRows();
        }
    }

    function SelectAllResult() {        
        $selectionChecks = $("div.SelectionCheckbox");
        if(($selectionChecks != 'undefined') && ($selectionChecks.length > 0)) {
            var grid = @dataGridId; 
            grid.SelectRows();
        }
    }    
}

@{
    if (searchComponents != null)
    {        
        @Html.DevExpress().RoundPanel(
            settings => {
                settings.Name = "rdpSearchParameters";
                settings.ShowHeader = false;
                settings.Width = System.Web.UI.WebControls.Unit.Percentage(100);
                settings.ControlStyle.CssClass = "searchParamPanel";
                settings.SetContent(() => {
                    ViewContext.Writer.WriteLine("<div id=\"searchParameters\">");
                    ViewContext.Writer.WriteLine("<div id=\"searchParamArea\">");
                    ViewContext.Writer.WriteLine("<table id=\"tblSearchParam\">");
                    int columnCount = @ViewBag.SearchParamColumn;
                    int componentCount = searchComponents.Length;
                    IHtmlComponent component;
                    int currentColumn = 0;
                    int index = 0;

                    while (index < componentCount)
                    {
                        component = searchComponents[index];
                        if (currentColumn == columnCount)
                        {
                            ViewContext.Writer.WriteLine("<tr>");
                            currentColumn = 0;
                        }
                        if (currentColumn == 0)
                        {
                            ViewContext.Writer.WriteLine("<tr>");
                        }         
                                       
                                        
                        ViewContext.Writer.WriteLine("<td class=\"cmFormLabel\">");
                        @Html.DevExpress().Label(
                            labelSettings =>
                            {
                                labelSettings.Name = "lbl" + component.GetId();
                                labelSettings.Text = component.GetName();
                                labelSettings.ControlStyle.CssClass = "dxInlineDisplay";
                                labelSettings.ControlStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                            }
                        ).Render();
                        ViewContext.Writer.WriteLine("</td>");  
                        ViewContext.Writer.WriteLine("<td class=\"cmFormField\">");         
                        @Html.cmDxComponent(component);
                        ViewContext.Writer.WriteLine("</td>");      

                        index++;
                        currentColumn++;
                    }
                    ViewContext.Writer.WriteLine("</tr>");
                    ViewContext.Writer.WriteLine("</table>");
                    ViewContext.Writer.WriteLine("</div>");
                    
                    ViewContext.Writer.WriteLine("<div class=\"searchButtonArea\">");
                    @Html.DevExpress().Button(
                        buttonSettings =>
                        {
                            buttonSettings.Name = "btSearch";
                            buttonSettings.Text = "Search";
                            buttonSettings.ControlStyle.CssClass = "searchButton";
                            buttonSettings.ClientSideEvents.Click = "UpdateSearchResult";
                        }
                    ).Render();
                    @Html.DevExpress().Button(
                        buttonSettings =>
                        {
                            buttonSettings.Name = "btClearParameters";
                            buttonSettings.Text = "Clear";
                            buttonSettings.ControlStyle.CssClass = "searchButton";
                            buttonSettings.ClientSideEvents.Click = "function(s,e) { clearSearchFields(); }";
                        }
                    ).Render();
                    ViewContext.Writer.WriteLine("</div>");
                    ViewContext.Writer.WriteLine("</div>");
                    
                    ViewContext.Writer.WriteLine("</div>");
                });
            }
        ).GetHtml()       
    }    
} 
<div id="searchResultTable">
    <div id="upperGridButtons">
        @Html.DevExpress().Button(
            settings =>
            {
                settings.Name = "btAdd";
                settings.Text = "Add";
                settings.ControlStyle.CssClass = "searchResultTableButtons";
                settings.ClientSideEvents.Click = "AddNewRecord";
            }
        ).GetHtml()
        @Html.DevExpress().Button(
            settings =>
            {
                settings.Name = "btDelete";
                settings.Text = "Delete";
                settings.ControlStyle.CssClass = "searchResultTableButtons";
                settings.ClientSideEvents.Click = "DeleteRecords";
            }
        ).GetHtml() 
        <div id="generalFunctionsGridUpperButtons" class="searchResultTableButtons">
            @Html.DevExpress().Button(
                settings =>
                {
                    settings.Name = "btClearResultSelection";
                    settings.Text = "Clear All";
                    settings.ControlStyle.CssClass = "rightFloatedButtons";
                    settings.ClientSideEvents.Click = "ClearResultSelections";
                }
            ).GetHtml()
        </div>        
    </div>
    <div id="dataGrid">
        @Html.Partial("LayoutGenerator/DefaultMaintenanceDataGrid", Model)
    </div>   
</div>